Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC

Bug 594406

Summary: dev-ros/image_geometry-1.12.1 : /.../cstdlib:75:25: fatal error: stdlib.h: No such file or directory
Product: Gentoo Linux Reporter: Toralf Förster <toralf>
Component: Current packagesAssignee: Robot Operating System team <ros>
Status: RESOLVED FIXED    
Severity: normal CC: plevine457, slyfox
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 582084    
Attachments: dev-ros:image_geometry-1.12.1:20160919-172525.log
emerge-history.txt
environment

Description Toralf Förster gentoo-dev 2016-09-19 18:00:11 UTC
                 from /var/tmp/portage/dev-ros/image_geometry-1.12.1/work/vision_opencv-1.12.1/image_geometry/include/image_geometry/pinhole_camera_model.h:4,
                 from /var/tmp/portage/dev-ros/image_geometry-1.12.1/work/vision_opencv-1.12.1/image_geometry/src/pinhole_camera_model.cpp:1:
/usr/lib/gcc/x86_64-pc-linux-gnu/6.2.0/include/g++-v6/cstdlib:75:25: fatal error: stdlib.h: No such file or directory
 #include_next <stdlib.h>
                         ^
compilation terminated.


$ cat emerge-info.txt
  -----------------------------------------------------------------

  This is an unstable amd64 chroot image (named amd64-13.0-unstable_20160915-200939) at a hardened host acting as a tinderbox.

  -----------------------------------------------------------------
  USE flags ...

  ... in make.conf:
USE="  pax_kernel xtpax -cdinstall -oci8 -bindist btrfs clang compat consolekit custom-cflags egl -eglfs evdev ext4 extra fontconfig git gles gnome-keyring gnuplot gnutls gstreamer inifile ithreads kerberos kvm lapack -latex ldap libinput libvirtd logrotate lvm mdnsresponder-compat -melt midi modplug mpg123 mta mysqli ncurses -offensive opus pam plotutils png python qml qt3support -qt5 rdoc sourceview ssh system-ffmpeg -thinkpad timidity tools udisks uml usbredir v4l v4l2 vala -vdpau video wma wxwidgets X -xcb xinetd xmp xvfb -ziffy"

  ... in /etc/portage/package.use/*:
  mail-mta/ssmtp      ssl mta
  net-misc/wget       ssl
  app-crypt/pinentry  -qt4
  app-editors/emacs   -dbus -svg -ssl -gtk -gtk3
  app-text/xmlto      -latex
  dev-libs/boehm-gc   threads
  dev-libs/libpcre    pcre16
  dev-qt/qtgui        egl eglfs
  net-nds/openldap    -sasl
  dev-util/cmake      -qt4 -qt5
  dev-vcs/git         -perl
  gnome-base/librsvg  -tools
  media-libs/mesa     -vaapi
  sys-apps/kmod       tools
  <=net-misc/openssh-7.3_p1-r2    -hpn
  net-misc/iputils -caps -filecaps
  >=app-crypt/gcr-3.20.0 gtk
  >=dev-libs/glib-2.48.2 dbus

  entries in /etc/portage/package.unmask/*:
  media-video/ffmpeg
  sys-devel/gcc:6.2.0
  -----------------------------------------------------------------

gcc-config -l:
 [1] x86_64-pc-linux-gnu-6.2.0 *
llvm-config --version:
3.8.1

Available Python interpreters, in order of preference:
  [1]   python3.4
  [2]   python2.7 (fallback)
  [3]   pypy (fallback)

  -----------------------------------------------------------------

Portage 2.3.1 (python 3.4.5-final-0, default/linux/amd64/13.0, gcc-6.2.0, glibc-2.23-r2, 4.7.4-hardened x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.7.4-hardened-x86_64-Intel-R-_Core-TM-_i7-3930K_CPU_@_3.20GHz-with-gentoo-2.3
KiB Mem:    65285480 total,   1826884 free
KiB Swap:   67108860 total,  67100212 free
Timestamp of repository gentoo: Mon, 19 Sep 2016 14:48:21 +0000
sh bash 4.3_p46
ld GNU ld (Gentoo 2.26.1 p1.0) 2.26.1
app-shells/bash:          4.3_p46::gentoo
dev-lang/perl:            5.24.0-r1::gentoo
dev-lang/python:          2.7.12::gentoo, 3.4.5::gentoo
dev-util/cmake:           3.6.2::gentoo
sys-apps/baselayout:      2.3::gentoo
sys-apps/openrc:          0.21.7::gentoo
sys-apps/sandbox:         2.10-r2::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r2::gentoo
sys-devel/automake:       1.11.6-r2::gentoo, 1.13.4-r1::gentoo, 1.14.1-r1::gentoo, 1.15-r2::gentoo
sys-devel/binutils:       2.26.1::gentoo
sys-devel/gcc:            6.2.0::gentoo
sys-devel/gcc-config:     1.8-r1::gentoo
sys-devel/libtool:        2.4.6-r2::gentoo
sys-devel/make:           4.2.1::gentoo
sys-kernel/linux-headers: 4.7::gentoo (virtual/os-headers)
sys-libs/glibc:           2.23-r2::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: 1

local
    location: /usr/local/portage
    masters: gentoo
    priority: 2

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /etc/stunnel/stunnel.conf /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/qpsmtpd/plugins"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/apache2-php7.0/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cgi-php7.0/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/php/cli-php7.0/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/var/tmp/distfiles"
EMERGE_DEFAULT_OPTS="--verbose --verbose-conflicts --color=n --nospinner --tree --quiet-build"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync network-sandbox parallel-fetch preserve-libs protect-owned sandbox sfperms strict test-fail-continue unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.uni-erlangen.de/pub/mirrors/gentoo rsync://mirror.netcologne.de/gentoo/ ftp://sunsite.informatik.rwth-aachen.de/pub/Linux/gor.bytemark.co.uk/gentoo/ rsync://ftp.snt.utwente.nl/gentoo"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j1"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X acl amd64 berkdb btrfs bzip2 clang cli compat consolekit cracklib crypt custom-cflags cxx dri egl evdev ext4 extra fontconfig fortran gdbm git gles gnome-keyring gnuplot gnutls gstreamer iconv inifile ipv6 ithreads kerberos kvm lapack ldap libinput libvirtd logrotate lvm mdnsresponder-compat midi mmx mmxext modplug modules mpg123 mta multilib mysqli ncurses nls nptl openmp opus pam pax_kernel pcre plotutils png python qml qt3support rdoc readline seccomp session sourceview sse sse2 ssh ssl system-ffmpeg tcpd timidity tools udisks uml unicode usbredir v4l v4l2 vala video wma wxwidgets xattr xinetd xmp xtpax xvfb zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" L10N="es-419 ga ms si ta-LK te zh-TW" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby20 ruby21" USERLAND="GNU" VIDEO_CARDS="amdgpu fbdev intel nouveau radeon radeonsi vesa dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 1 Toralf Förster gentoo-dev 2016-09-19 18:00:17 UTC
Created attachment 446708 [details]
dev-ros:image_geometry-1.12.1:20160919-172525.log
Comment 2 Toralf Förster gentoo-dev 2016-09-19 18:00:20 UTC
Created attachment 446710 [details]
emerge-history.txt
Comment 3 Toralf Förster gentoo-dev 2016-09-19 18:00:23 UTC
Created attachment 446712 [details]
environment
Comment 4 Sergei Trofimovich gentoo-dev 2016-09-19 21:57:02 UTC
It injects /usr/include with -isystem

    /usr/bin/x86_64-pc-linux-gnu-g++  -Dimage_geometry_EXPORTS -isystem //usr/include -isystem /usr/include/opencv -I/var/tmp/portage/dev-ros/image_geometry-1.12.1/work/vision_opencv-1.12.1/image_geometry/include   -DNDEBUG -march=native -O2 -pipe  -fPIC   -o CMakeFiles/image_geometry.dir/src/pinhole_camera_model.cpp.o -c /var/tmp/portage/dev-ros/image_geometry-1.12.1/work/vision_opencv-1.12.1/image_geometry/src/pinhole_camera_model.cpp

presumably with

    include_directories(SYSTEM ${catkin_INCLUDE_DIRS}
                               ${OpenCV_INCLUDE_DIRS}
    )

g++ has it's own stdlib.h implementation and cstdlib->stdlib.h got broken by
skipping gcc's stdlib.h.
Comment 5 Peter Levine 2016-09-20 00:32:32 UTC
Submitted pull-request:

https://github.com/ros-perception/vision_opencv/pull/152
Comment 6 Peter Levine 2016-09-21 07:22:52 UTC
(In reply to Peter Levine from comment #5)
> Submitted pull-request:
> 
> https://github.com/ros-perception/vision_opencv/pull/152

Pull request accepted upstream.

https://github.com/ros-perception/vision_opencv/commit/4cbcb7b36ef4d2048bbc02b9923e76f11a93da0a
Comment 7 Sergei Trofimovich gentoo-dev 2016-09-21 08:05:08 UTC
> Pull request accepted upstream.
> 
> https://github.com/ros-perception/vision_opencv/commit/
> 4cbcb7b36ef4d2048bbc02b9923e76f11a93da0a

Pushed it to ::gentoo as:

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=009a858967cb9d39fce4d4fcd1f618dfd7299f21

Thank you!